require "sqlite3"
require "yaml"

class Schdlr
  class Queue
    class Sqlite
      INITIAL_STATUS = 'queued'
      FAILED_STATUS = 'failed'

      def initialize(name='test.db')
        @db = SQLite3::Database.new(name)
        @db.execute %(
          create table if not exists tasks (
            id integer PRIMARY KEY,
            scheduled_at integer,
            status varchar(30),
            name varchar(30)
          );)
      end

      def set(timestamp, task_spec)
        #TODO: should raise if timestamp is not a proper date
        @db.execute("INSERT INTO tasks (scheduled_at, name, status) VALUES (?, ?, ?)", [timestamp.to_i, task_spec.to_yaml, INITIAL_STATUS])
      end

      def get(key)
        @db.execute("SELECT * FROM tasks WHERE id IN (?)", key)
      end

      def tasks(at_time=nil)
        if at_time
          @db.execute("SELECT * FROM tasks WHERE scheduled_at <= ? and status = ?", [at_time.to_i, INITIAL_STATUS])
        else
          @db.execute("SELECT * FROM tasks")
        end
      end

      def del(*keys)
        @db.execute("DELETE FROM tasks WHERE id IN (?)", keys)
      end

      def fail(*keys)
        @db.execute("UPDATE tasks SET status = '#{FAILED_STATUS}' WHERE id IN (?)", keys)
      end

      def drop_all!
        @db.execute("DELETE FROM tasks")
      end

    end
  end
end